﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using FirstTouchHid; //Solution Explorer RMB auf References Add Reference Browse PSoCFirstTouchUSBNet.lib


namespace USB_I2C_App_01
{
    public partial class Form1 : Form
    {       
        private double xmin, xmax, ymin, ymax;
        private double xStreckfaktor, yStreckfaktor;
        double yA=0;
        //Gadget is in this case PSoC FirstTouch Starter Kit
        private FirstTouchHidDevice pGadget = null;
        const int n_data = 65;
        private byte[] cmd_bytes = new byte[n_data];
        private byte[] data_bytes = new byte[n_data];
        IntPtr ip_USB_EventHandle;
        private Guid g_DeviceClass;
        private int NumProc;
        const int cmd_read = 0;
        const int cmd_write = 1;
        const int I2Ccom_address = 4; //See PSoC Express and the I2C-properties
        int n_w, n_x = 0;

        public Form1()
        {
            //Is the application already running?
            Process[] processName = Process.GetProcessesByName("USB_I2C_App_01");
            if (processName != null)
            {
                NumProc = processName.Length;
                if (NumProc > 1)
                {
                    MessageBox.Show("PSoC FirstTouch Starter Kit already running.", "ERROR",
                                MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    Environment.Exit(1);
                }
                else
                {
                    //MessageBox.Show("USB_I2C_App_01", "ok",
                    //            MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
            InitializeComponent();
            timer1.Interval = 1;  //minimal 1; 1000=1000ms
            n_w = this.ClientRectangle.Width;
            xmax = n_w;
            xmin = -50;
            ymax = 1810;
            ymin = -50;
            xStreckfaktor = this.ClientRectangle.Width / (xmax - xmin);
            yStreckfaktor = this.ClientRectangle.Height / (ymax - ymin);
            

            /*Is the gadget connected?*/
            if (GetHidDevice())
            {
                this.Text = "Connected";
                this.timer1.Enabled = true;
            }
            else
            {
                this.Text = "Disconnected";
                this.timer1.Enabled = false;
                MessageBox.Show("GetHidDevice()", "Disconnected",
                                MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }
        public int xX(double x)
        {
            return (int)Math.Round(xStreckfaktor * (x - xmin));
        }

        public int yY(double y)
        {
            return (int)Math.Round(yStreckfaktor * (ymax - y));
        }

        public double Xx(int x)
        {
            return x / xStreckfaktor + xmin;
        }

        public double Yy(int y)
        {
            return ymax - y / yStreckfaktor;
        }

        public void Koordinatensystem(Graphics g, double dx, double dy, double hier_yAchse)
        {
            Font fn = new Font("Verdana", 12);
            Brush br = new SolidBrush(Color.DimGray);
            Pen pen = new Pen(Color.Red, 1/*Strichdicke*/);

            Point[] pxA =
            {
                new Point(xX(xmax),yY(0)),
                new Point(xX(xmax) - 18,yY(0) - 9),
                new Point(xX(xmax) - 18,yY(0) + 9),
                new Point(xX(xmax),yY(0))
            };
            int h = menuStrip1.Height;
            Point[] pyA =
            { 
                new Point(xX(hier_yAchse) + 9, yY(ymax) + 18 + h),
                new Point(xX(hier_yAchse), yY(ymax)-2 + h),
                new Point(xX(hier_yAchse) - 9, yY(ymax) + 18 + h),
                new Point(xX(hier_yAchse) + 9, yY(ymax) + 18 + h)
            };

            g.DrawLine(pen, xX(xmin), yY(0), xX(xmax), yY(0));//x-Achse
            g.FillPolygon(br, pxA);//Pfeil der x-Achse

            g.DrawLine(pen, xX(hier_yAchse), yY(ymin), xX(hier_yAchse), yY(ymax));//y-Achse
            g.FillPolygon(br, pyA);//Pfeil der y-Achse


            double x = dx;
            while (x < xmax)
            {
                g.DrawString(x.ToString("#.#"), fn, br, xX(x), yY(0) + 3);
                g.DrawRectangle(pen, xX(x), yY(0), 1, 3);
                x += dx;
            }
            x = -dx;
            while (x > xmin)
            {
                g.DrawString(x.ToString(), fn, br, xX(x), yY(0) + 3);
                g.DrawRectangle(pen, xX(x), yY(0), 1, 3);
                x -= dx;
            }
            x = dy;
            while (x < ymax)
            {
                g.DrawString(x.ToString("0.#####"), fn, br, xX(hier_yAchse) + 5, yY(x));
                g.DrawRectangle(pen, xX(hier_yAchse), yY(x), 3, 1);
                x += dy;
            }
            x = -dy;
            while (x > ymin)
            {
                g.DrawString(x.ToString("0.#####"), fn, br, xX(hier_yAchse) + 5, yY(x));
                g.DrawRectangle(pen, xX(hier_yAchse), yY(x), 3, 1);
                x -= dy;
            }
        }

        //Support for Human Interface devices (HID)
        private bool GetHidDevice()
        {
            bool Status = false;
            //idVendor:  0x04B4 = Cypress Semiconductor
            //idProduct: 0xF110 with UVCView.x86.exe
            //http://msdn2.microsoft.com/en-us/library/aa906848.aspx
            pGadget = FirstTouchHidDevice.FindFirstTouchDevice(0x04b4, 0xF110);
            if (pGadget != null){Status = true;}
            //RegisterForUsbEvents: attach/removal
            g_DeviceClass = Win32Usb.HIDGuid;
            //Class View then RMB at FirstTouchHid then Browse Definition
            ip_USB_EventHandle = Win32Usb.RegisterForUsbEvents(this.Handle, g_DeviceClass);
            return (Status);
        }

        private void write_to_IC(Byte IC_address, Byte n_bytes, Byte read_or_write_byte)
        {
            if (read_or_write_byte == cmd_read)cmd_bytes[1] = 0x00;
            else if (read_or_write_byte == cmd_write)cmd_bytes[1] = 0x01;

            cmd_bytes[2] = n_bytes;
            cmd_bytes[3] = IC_address;
            
            pGadget.WriteToPSoC(cmd_bytes);
        }

        private bool read_from_IC(Byte IC_address, Byte n_bytes)
        {
            int sleep_time;
            bool Status = true;
            //calculate the sleep_time
            sleep_time = 1 + (n_bytes / 8);
            //inform IC what you want: read
            if (pGadget != null && data_bytes != null)
            {
                try{write_to_IC(IC_address, n_bytes, cmd_read);}
                catch{}
            }
            //Since USB and I2C needs time
            System.Threading.Thread.Sleep(sleep_time);
            //read what you get from the IC via USB_I2C
            if (pGadget != null)
            {
                data_bytes = pGadget.ReadFromPSoC();
            }
            //is there anything?
            if (data_bytes == null)
            {
                Status = false;
            }    
            return (Status);
        }

        //An Event is called when a new device is detected
        protected override void WndProc(ref Message m)
        {
            if (m.Msg == Win32Usb.WM_DEVICECHANGE)	//WM: An USB Device has changed
            {
                switch (m.WParam.ToInt32()) 
                {
                    case Win32Usb.DEVICE_ARRIVAL:   //USB-Gadget inserted
                        if (GetHidDevice())
                        {
                            this.Text = "Connected";
                            timer1.Enabled = true;
                        }
                        break;
                    case Win32Usb.DEVICE_REMOVECOMPLETE:    //USB-Gadget inserted
                        if (!GetHidDevice())
                        {
                            this.Text = "Disconnected";
                            timer1.Enabled = false;
                        }
                        break;
                }
            }
            //Debug.WriteLine(m); //View/Output RMB Clear all
            base.WndProc(ref m);
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            //Unter Form1.cs[Design]* unten timer1 Properties kann man die Zeit Einstellen
            timer1.Enabled = false;
            Graphics g = Graphics.FromHwnd(Handle);
            Pen pn = new Pen(Brushes.Black);
            pn.Width = 2;
            int y=0;
            if (read_from_IC(I2Ccom_address, n_data - 2))
            {

                //y = (data_bytes[1]*255) + data_bytes[2];
                y = (data_bytes[1]<<8) + data_bytes[2];
                if (n_x <= n_w)
                {
                    g.DrawLine(pn, xX(n_x), yY(y), xX(n_x) + 2, yY(y));
                    n_x++;
                }
                
            }
            timer1.Enabled = true;
            //this.Refresh();
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            Font fn = new Font("Verdana", 12);
            Brush br = new SolidBrush(Color.Blue);
/*            
            int n;
            for (n = 0; n < n_data; n++)
                g.DrawString(n.ToString() + ": " + data_bytes[n].ToString(), fn, br,
                    10 + (n / 21) * 100, ((n % 21) * 30) + 30);
*/            
            Koordinatensystem(g, xmax / 5, ymax / 5, yA);
            timer1.Enabled = true;
            
        }

        private void Form1_SizeChanged(object sender, EventArgs e)
        {
            xStreckfaktor = this.ClientRectangle.Width / (xmax - xmin);
            yStreckfaktor = this.ClientRectangle.Height / (ymax - ymin);
            n_w = this.ClientRectangle.Width;
            n_x = 0;
            this.Refresh();
        }

    }
}
